#lang scheme

;; find-val : list-of-(cons X Y) X (-> Y) -> Y
(define (find-val lst key fail-k)
  (cond
    [(empty? lst) (fail-k)]
    [else (if (equal? (car (car lst)) key)
              (cdr (car lst))
              (find-val (cdr lst) key fail-k))]))

(find-val '((x . 1) (y . 2) (z . 3)) 'x (lambda () #f)) "should be" 1
(find-val '((x . 1) (y . 2) (z . 3)) 'a  (lambda () #f)) "should be" #f
(find-val '((x . 1) (y . #f) (z . 3)) 'y (lambda () 'not-there)) "should be" #f
(find-val '((x . 1) (y . #f) (z . 3)) 'a (lambda () 'not-there)) "should be" 'not-there
